package org.codehaus.mojo.taglist;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.maven.plugin.AbstractMojo;
import org.apache.maven.plugin.MojoExecutionException;

/**
 * Display help information on taglist-maven-plugin.<br/> Call <pre>  mvn taglist:help -Ddetail=true -Dgoal=&lt;goal-name&gt;</pre> to display parameter details.
 *
 * @version generated on Thu Sep 03 12:41:59 CEST 2009
 * @author org.apache.maven.tools.plugin.generator.PluginHelpGenerator (version 2.5)
 * @goal help
 * @requiresProject false
 */
public class HelpMojo
    extends AbstractMojo
{
    /**
     * If <code>true</code>, display all settable properties for each goal.
     * 
     * @parameter expression="${detail}" default-value="false"
     */
    private boolean detail;

    /**
     * The name of the goal for which to show help. If unspecified, all goals will be displayed.
     * 
     * @parameter expression="${goal}"
     */
    private java.lang.String goal;

    /**
     * The maximum length of a display line, should be positive.
     * 
     * @parameter expression="${lineLength}" default-value="80"
     */
    private int lineLength;

    /**
     * The number of spaces per indentation level, should be positive.
     * 
     * @parameter expression="${indentSize}" default-value="2"
     */
    private int indentSize;


    /** {@inheritDoc} */
    public void execute()
        throws MojoExecutionException
    {
        if ( lineLength <= 0 )
        {
            getLog().warn( "The parameter 'lineLength' should be positive, using '80' as default." );
            lineLength = 80;
        }
        if ( indentSize <= 0 )
        {
            getLog().warn( "The parameter 'indentSize' should be positive, using '2' as default." );
            indentSize = 2;
        }

        StringBuffer sb = new StringBuffer();

        append( sb, "org.codehaus.mojo:taglist-maven-plugin:2.4", 0 );
        append( sb, "", 0 );

        append( sb, "Taglist Maven Plugin", 0 );
        append( sb, "Produce a tag list report.", 1 );
        append( sb, "", 0 );

        if ( goal == null || goal.length() <= 0 )
        {
            append( sb, "This plugin has 2 goals:", 0 );
            append( sb, "", 0 );
        }

        if ( goal == null || goal.length() <= 0 || "help".equals( goal ) )
        {
            append( sb, "taglist:help", 0 );
            append( sb, "Display help information on taglist-maven-plugin.\nCall\n\u00a0\u00a0mvn\u00a0taglist:help\u00a0-Ddetail=true\u00a0-Dgoal=<goal-name>\nto display parameter details.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "detail (Default: false)", 2 );
                append( sb, "If true, display all settable properties for each goal.", 3 );
                append( sb, "", 0 );

                append( sb, "goal", 2 );
                append( sb, "The name of the goal for which to show help. If unspecified, all goals will be displayed.", 3 );
                append( sb, "", 0 );

                append( sb, "indentSize (Default: 2)", 2 );
                append( sb, "The number of spaces per indentation level, should be positive.", 3 );
                append( sb, "", 0 );

                append( sb, "lineLength (Default: 80)", 2 );
                append( sb, "The maximum length of a display line, should be positive.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "taglist".equals( goal ) )
        {
            append( sb, "taglist:taglist", 0 );
            append( sb, "Scans the source files for tags and generates a report on their occurrences.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "aggregate (Default: false)", 2 );
                append( sb, "Whether to build an aggregated report at the root, or build individual reports.", 3 );
                append( sb, "", 0 );

                append( sb, "emptyComments (Default: true)", 2 );
                append( sb, "This parameter indicates whether to look for tags even if they don\'t have a comment.", 3 );
                append( sb, "", 0 );

                append( sb, "encoding (Default: ${project.build.sourceEncoding})", 2 );
                append( sb, "Specifies the character encoding of the source files.", 3 );
                append( sb, "", 0 );

                append( sb, "linkXRef (Default: true)", 2 );
                append( sb, "Link the tag line numbers to the source xref. Defaults to true and will link automatically if jxr plugin is being used.", 3 );
                append( sb, "", 0 );

                append( sb, "multipleLineComments (Default: true)", 2 );
                append( sb, "This parameter indicates whether for simple tags (like \'TODO\'), the analyzer should look for multiple line comments.", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory (Default: ${project.reporting.outputDirectory})", 2 );
                append( sb, "The output directory for the report. Note that this parameter is only evaluated if the goal is run directly from the command line or from a build life cycle phase. If the goal is run indirectly as part of a site generation, the output directory configured in the Maven Site Plugin is used instead.", 3 );
                append( sb, "", 0 );

                append( sb, "showEmptyDetails (Default: false)", 2 );
                append( sb, "This parameter indicates whether to generate details for tags with zero occurrences.", 3 );
                append( sb, "", 0 );

                append( sb, "skipTestSources (Default: false)", 2 );
                append( sb, "Skips reporting of test sources.", 3 );
                append( sb, "", 0 );

                append( sb, "sourceFileLocale (Default: en)", 2 );
                append( sb, "Specifies the Locale of the source files.", 3 );
                append( sb, "", 0 );

                append( sb, "tagListOptions", 2 );
                append( sb, "Defines each tag class (grouping) and the individual tags within each class. The user can also specify a title for each tag class and the matching logic used by each tag.\n-\tExact Match\n\t<matchString>todo</matchString>\n\t<matchType>exact</matchType>\n\tMatches: todo\n-\tIgnore Case Match\n\t<matchString>todo</matchString>\n\t<matchType>ignoreCase</matchType>\n\tMatches: todo, Todo, TODO...\n-\tRegular Expression Match\n\t<matchString>tod[aeo]</matchString>\n\t<matchType>regEx</matchType>\n\tMatches: toda, tode, todo\n\n\nFor complete examples see the Usage page.\n\nThe legacy tags configuration remains for backwards compatibility, and the simultaneous use of both the tags and tagListOptions is permitted; however the tags configuration should be avoided whenever possible because those strings are only checked using the exact match logic.", 3 );
                append( sb, "", 0 );

                append( sb, "tags", 2 );
                append( sb, "Deprecated as of version 2.4. The configuration tagListOptions should be used instead of tags.\n\nList of tags to look for, specified as <tag> tags. The tags can be either:\n-\tJavadoc tags: \'@todo\' for instance\n-\tSimple tags: \'TODO\' for instance. In this case, the tags will be searched in any Java comment (//, /* or /**).\n", 3 );
                append( sb, "", 0 );

                append( sb, "testXrefLocation (Default: ${project.reporting.outputDirectory}/xref-test)", 2 );
                append( sb, "Location of the Test Xrefs to link to.", 3 );
                append( sb, "", 0 );

                append( sb, "xmlOutputDirectory (Default: ${project.build.directory}/taglist)", 2 );
                append( sb, "Specifies the directory where the xml output will be generated.", 3 );
                append( sb, "", 0 );

                append( sb, "xrefLocation (Default: ${project.reporting.outputDirectory}/xref)", 2 );
                append( sb, "Location of the Xrefs to link to.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( getLog().isInfoEnabled() )
        {
            getLog().info( sb.toString() );
        }
    }

    /**
     * <p>Repeat a String <code>n</code> times to form a new string.</p>
     *
     * @param str String to repeat
     * @param repeat number of times to repeat str
     * @return String with repeated String
     * @throws NegativeArraySizeException if <code>repeat < 0</code>
     * @throws NullPointerException if str is <code>null</code>
     */
    private static String repeat( String str, int repeat )
    {
        StringBuffer buffer = new StringBuffer( repeat * str.length() );

        for ( int i = 0; i < repeat; i++ )
        {
            buffer.append( str );
        }

        return buffer.toString();
    }

    /** 
     * Append a description to the buffer by respecting the indentSize and lineLength parameters.
     * <b>Note</b>: The last character is always a new line.
     * 
     * @param sb The buffer to append the description, not <code>null</code>.
     * @param description The description, not <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     */
    private void append( StringBuffer sb, String description, int indent )
    {
        for ( Iterator it = toLines( description, indent, indentSize, lineLength ).iterator(); it.hasNext(); )
        {
            sb.append( it.next().toString() ).append( '\n' );
        }
    }

    /** 
     * Splits the specified text into lines of convenient display length.
     * 
     * @param text The text to split into lines, must not be <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     * @return The sequence of display lines, never <code>null</code>.
     * @throws NegativeArraySizeException if <code>indent < 0</code>
     */
    private static List toLines( String text, int indent, int indentSize, int lineLength )
    {
        List lines = new ArrayList();

        String ind = repeat( "\t", indent );
        String[] plainLines = text.split( "(\r\n)|(\r)|(\n)" );
        for ( int i = 0; i < plainLines.length; i++ )
        {
            toLines( lines, ind + plainLines[i], indentSize, lineLength );
        }

        return lines;
    }

    /** 
     * Adds the specified line to the output sequence, performing line wrapping if necessary.
     * 
     * @param lines The sequence of display lines, must not be <code>null</code>.
     * @param line The line to add, must not be <code>null</code>.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     */
    private static void toLines( List lines, String line, int indentSize, int lineLength )
    {
        int lineIndent = getIndentLevel( line );
        StringBuffer buf = new StringBuffer( 256 );
        String[] tokens = line.split( " +" );
        for ( int i = 0; i < tokens.length; i++ )
        {
            String token = tokens[i];
            if ( i > 0 )
            {
                if ( buf.length() + token.length() >= lineLength )
                {
                    lines.add( buf.toString() );
                    buf.setLength( 0 );
                    buf.append( repeat( " ", lineIndent * indentSize ) );
                }
                else
                {
                    buf.append( ' ' );
                }
            }
            for ( int j = 0; j < token.length(); j++ )
            {
                char c = token.charAt( j );
                if ( c == '\t' )
                {
                    buf.append( repeat( " ", indentSize - buf.length() % indentSize ) );
                }
                else if ( c == '\u00A0' )
                {
                    buf.append( ' ' );
                }
                else
                {
                    buf.append( c );
                }
            }
        }
        lines.add( buf.toString() );
    }

    /** 
     * Gets the indentation level of the specified line.
     * 
     * @param line The line whose indentation level should be retrieved, must not be <code>null</code>.
     * @return The indentation level of the line.
     */
    private static int getIndentLevel( String line )
    {
        int level = 0;
        for ( int i = 0; i < line.length() && line.charAt( i ) == '\t'; i++ )
        {
            level++;
        }
        for ( int i = level + 1; i <= level + 4 && i < line.length(); i++ )
        {
            if ( line.charAt( i ) == '\t' )
            {
                level++;
                break;
            }
        }
        return level;
    }
}
